#pragma once

#include <glow-extras/viewer/view.hh>

namespace glow::viewer::experimental
{
/// Query the 3D position at the given pixel, only usable in interactive viewers
inline tg::optional<tg::pos3> interactive_get_position(int x, int y) { return detail::query_current_viewer_3d_position(x, y); }

/// Query the 3D position at the given pixel, only usable in interactive viewers
inline tg::optional<tg::pos3> interactive_get_position(tg::pos2 const pos) { return interactive_get_position(pos.x, pos.y); }

/// Get the window size, only usable in interactive viewers
inline tg::isize2 interactive_get_window_size() { return detail::query_current_viewer_window_size(); }

/// Get the last valid mouse postition, only usable in interactive viewers.
inline tg::pos2 interactive_get_mouse_position() { return detail::query_mouse_position(); }

}
